<template>
  <div class="columns four">
    <label for="workINN">ИНН</label>
    <input type="text"
           id="workINN"
           name="ИНН"
           :class="getValidateClass('ИНН')"
           v-model="$user.workINN"
           v-validate="typeIP"
           v-mask="maskIP"
           autocomplete="off"
           data-code="workINNInvalidFormat"
    />
    <validate-message v-show="vErrors.has('ИНН')">
      {{ vErrors.first('ИНН') }}
    </validate-message>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import { REQUIRED_FIELD, LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

  export default {
    name: 'businessman',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    computed: {
      typeIP () {
        if (this.$user.typeOfEmployment === 2) {
          return 'required|length:12'
        }
        if (this.$user.typeOfEmployment === 3) {
          return 'required|length:10'
        }
      },
      maskIP () {
        if (this.$user.typeOfEmployment === 2) {
          return '############'
        }
        if (this.$user.typeOfEmployment === 3) {
          return '##########'
        }
      }
    },
    components: {
      ValidateMessage
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(LENGHT)
    },
    updated () {
      this.$user.validate.other.businessman = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    }
  }
</script>

<style scoped lang="scss">

</style>
